unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    R: TLabel;
    G: TLabel;
    B: TLabel;
    RBar: TScrollBar;
    GBar: TScrollBar;
    BBar: TScrollBar;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure ChangeColor(Sender: TObject);
  private
    Pic: TPicture;
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  Pic:=TPicture.Create;
  Pic.LoadFromFile('PNG_transparency_demonstration_1.png');
  Color:=0;
  RBar.Position:=0;
  GBar.Position:=0;
  BBar.Position:=0;
  Doublebuffered:=True;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  Bitmap: TBitmap;
begin
  Bitmap:=TBitmap.Create;
  Bitmap.SetSize(ClientWidth, ClientHeight);
  Bitmap.Canvas.CopyRect(ClientRect, Canvas, ClientRect);
  Bitmap.SaveToFile('Test.bmp');
  Bitmap.Free;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  Pic.Free;
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
  Canvas.StretchDraw(ClientRect, Pic.Bitmap);
end;

procedure TForm1.ChangeColor(Sender: TObject);
begin
  Color:=
    RBar.Position +
    GBar.Position shl 8 +
    BBar.Position shl 16;

  Invalidate;
end;

end.

